package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type UpdateFloatingIPLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewUpdateFloatingIPLogic(ctx context.Context, svcCtx *svc.ServiceContext) *UpdateFloatingIPLogic {
	return &UpdateFloatingIPLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *UpdateFloatingIPLogic) UpdateFloatingIP(req *types.UpdateFloatingIPReq) (resp *types.UpdateFloatingIPResp, err error) {
	// todo: add your logic here and delete this line
	UpdateFloatingIPReq := &openstack.UpdateFloatingIPReq{}
	err = copier.CopyWithOption(UpdateFloatingIPReq, req, copier.Option{Converters: utils.Converters})
	UpdateFloatingIPResp, err := l.svcCtx.OpenstackRpc.UpdateFloatingIP(l.ctx, UpdateFloatingIPReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&UpdateFloatingIPResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &UpdateFloatingIPResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
